#!/usr/bin/ruby
require 'rubygems'
require 'pg'

$: << File.dirname(__FILE__)
require 'controller'

inner_loops = 12         # 5 s per read-out

begin
  conn = PG.connect(:dbname => 'darkside50', :host => 'dsdb', :user => 'daq', :password => 'daq')
  conn.prepare("insert_dark_rate", "insert into tpc_monitor.dark_rates (time, values) values ($1, $2)")
rescue
  puts 'Database not available'
  conn = nil
end

ctl = Controller.new :channels => 40
if ctl.check_device
  ctl.device_info
  ctl.device_init('fw.bit')
  s = [];
  while true
    inner_loops.times do
      v = ctl.rates()
      s << v
      8.times { |column| print " FE#{column + 1}\t" }
      puts "       #{Time.now.strftime("%H:%M:%S")}\n"
      5.times do |row|
	8.times do |column|
	  print v[row + column * 5].to_s + "\t"
	end
	puts "\n"
      end
      puts "\n"
    end
    r = s.transpose.map { |x| x.reduce(:+) / inner_loops }
    conn.exec_prepared("insert_dark_rate", ['NOW', '{' +  r.join(',') + '}' ]) if conn
    s.clear
  end
else
  p 'no controller found'
end
