#!/bin/bash

if [ $# -ne 1 -a $# -ne 2 ]; then
  echo "usage $0 channel_number (0 base) [days]"
  exit
fi

idx=$1
let "idx += 2"
days=${2:-1}
echo $days

tz=`date +%z | tr -d 0`



export PGPASSWORD=der
psql -A -q -c "select EXTRACT( epoch FROM time) + 3600 * $tz, values from tpc_monitor.dark_rates where time > now()::date - INTERVAL '$days day';" -h ds50daq.lngs.infn.it darkside50 rea | tr -d '{}' | tr -s '|,' '  ' | grep ^1 | gnuplot -p -e 'set xdata time; set timefmt "%s"; set format x "%H:%M %d/%m"; set xtics font "Times-Roman, 6"; set yrange [0:400]; plot "-" using 1:'$idx' with lines title "ch:'$1'"'
