#!/usr/bin/ruby
require 'rubygems'
require 'serialport'

class USB_ISS
  def initialize(file)
    begin
      @sp = SerialPort.open(file, 19200) 
      @sp.read_timeout = 500
    rescue
      $stderr.print 'can not create device: ' + $!.to_s + "\n"
      exit
    end
  end

  def send(l)
    p l
    c = l.map { |x| x.to_i(16) }.pack('C*')
    @sp.write c
    r = sp.read.unpack('C*').map { |x| '0x' + x.to_s(16) }
    p r
  end
end

dev = USB_ISS.new ARGV.shift
dev.send [ "0x5a", "0x2", "0x50", "0" ]  # I2C 400 kbit/s
dev.send ARGV

