
#include "ds50daq/Compression/Codes.hh"
#include "ds50daq/Compression/ExpDecode.hh"

#include <iostream>
#include <cassert>

using namespace std;
using namespace ds50;

ADCCountVec input_data_12 = { 1 };

ADCCountVec input_data_12a
( {
  484, 311,  342,  497,  373,  466,  547,  538,  421,  384,  552,  505,
    391,  481,  544,  756,  620,  447,  563,  475,  543,  438,  482,
    503,  417,  557,  520,  692,  507,  288,  540,  421
    }
  );

ADCCountVec input_data_14
( {
  8484, 8311,  8342,  8497,  8373,  8466,  8547,  8538,  8421,  9384,  9552,  9505,
    14391,  14481,  14544,  14756,  620,  447,  563,  475,  4543,  4438,  4482,
    4503,  4417,  11557,  1520,  1692,  1507,  1288,  540,  421
    }
  );

template<int N>
void execute(ADCCountVec const& in, SymTable const& pod_table)
{
  DataVec comp(100);
  ADCCountVec out(in.size());

  unsigned long bit_count  = rleAndCompress(N,in, 
					       comp, pod_table, 0);

  decodePod(N, bit_count, comp, out);
  assert(out == in);
}

int main()
{
  SymTable pod_table;
  generateTable(pod, pod_table, 50);

  ADCCountVec i_1x_1 = { 1 };
  ADCCountVec i_1x_2 = { 2 };
  ADCCountVec i_1x_3 = { 3 };

  ADCCountVec i_12_1 = { 0x0800 };
  ADCCountVec i_12_2 = { 0x0ff7 };
  ADCCountVec i_12_3 = { 0x0fff };
  ADCCountVec i_12_4 = { 1,2,3,0x0800, 0xff7, 0x0fff };

  ADCCountVec i_14_1 = { 0x2000 };
  ADCCountVec i_14_2 = { 0x3ff7 };
  ADCCountVec i_14_3 = { 0x3fff };
  ADCCountVec i_14_4 = { 1,2,3,0x2000, 0x3ff7, 0x03fff };

  execute<12>(i_1x_1, pod_table);
  execute<12>(i_1x_2, pod_table);
  execute<12>(i_1x_3, pod_table);

  execute<12>(i_12_1, pod_table);
  execute<12>(i_12_2, pod_table);
  execute<12>(i_12_3, pod_table);
  execute<12>(i_12_4, pod_table);

  execute<14>(i_1x_1, pod_table);
  execute<14>(i_1x_2, pod_table);
  execute<14>(i_1x_3, pod_table);

  execute<14>(i_14_1, pod_table);
  execute<14>(i_14_2, pod_table);
  execute<14>(i_14_3, pod_table);
  execute<14>(i_14_4, pod_table);

  return 0;
}
